/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.PhoneNumberPrefixRecord;

import java.util.Arrays;
import java.util.List;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class PhoneNumberPrefix extends TableImpl<PhoneNumberPrefixRecord> {

	private static final long serialVersionUID = 1112248015;

	/**
	 * The reference instance of <code>public.phone_number_prefix</code>
	 */
	public static final PhoneNumberPrefix PHONE_NUMBER_PREFIX = new PhoneNumberPrefix();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<PhoneNumberPrefixRecord> getRecordType() {
		return PhoneNumberPrefixRecord.class;
	}

	/**
	 * The column <code>public.phone_number_prefix.id</code>.
	 */
	public final TableField<PhoneNumberPrefixRecord, Long> ID = createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.phone_number_prefix.name</code>.
	 */
	public final TableField<PhoneNumberPrefixRecord, String> NAME = createField("name", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

	/**
	 * The column <code>public.phone_number_prefix.prefix</code>.
	 */
	public final TableField<PhoneNumberPrefixRecord, String> PREFIX = createField("prefix", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

	/**
	 * The column <code>public.phone_number_prefix.phone_number_count</code>.
	 */
	public final TableField<PhoneNumberPrefixRecord, Integer> PHONE_NUMBER_COUNT = createField("phone_number_count", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaulted(true), this, "");

	/**
	 * Create a <code>public.phone_number_prefix</code> table reference
	 */
	public PhoneNumberPrefix() {
		this("phone_number_prefix", null);
	}

	/**
	 * Create an aliased <code>public.phone_number_prefix</code> table reference
	 */
	public PhoneNumberPrefix(String alias) {
		this(alias, PHONE_NUMBER_PREFIX);
	}

	private PhoneNumberPrefix(String alias, Table<PhoneNumberPrefixRecord> aliased) {
		this(alias, aliased, null);
	}

	private PhoneNumberPrefix(String alias, Table<PhoneNumberPrefixRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Identity<PhoneNumberPrefixRecord, Long> getIdentity() {
		return Keys.IDENTITY_PHONE_NUMBER_PREFIX;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<PhoneNumberPrefixRecord> getPrimaryKey() {
		return Keys.PHONE_NUMBER_PREFIX_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<PhoneNumberPrefixRecord>> getKeys() {
		return Arrays.<UniqueKey<PhoneNumberPrefixRecord>>asList(Keys.PHONE_NUMBER_PREFIX_PKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public PhoneNumberPrefix as(String alias) {
		return new PhoneNumberPrefix(alias, this);
	}

	/**
	 * Rename this table
	 */
	public PhoneNumberPrefix rename(String name) {
		return new PhoneNumberPrefix(name, null);
	}
}
